glibmm: Gio::SocketConnection Class Reference

glibmm 2.38.1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gio::SocketConnection Class Reference
Portable Network I/O Functionality

A socket connection. More...

`#include <giomm/socketconnection.h>`

Inheritance diagram for Gio::SocketConnection:
[legend]

## Public Member Functions
virtual | ~SocketConnection ()
GSocketConnection* | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketConnection* | gobj () const
| Provides access to the underlying C GObject. More...
GSocketConnection* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | connect (const Glib::RefPtr< SocketAddress >& address, const Glib::RefPtr< Cancellable >& cancellable)
| Connect connection to the specified remote address. More...
bool | connect (const Glib::RefPtr< SocketAddress >& address)
| A connect() convenience overload. More...
void | connect_async (const Glib::RefPtr< SocketAddress >& address, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable)
| Asynchronously connect this connection to the specified remote address. More...
void | connect_async (const Glib::RefPtr< SocketAddress >& address, const SlotAsyncReady& slot)
| A non-cancellable version of connect_async(). More...
bool | connect_finish (const Glib::RefPtr< AsyncResult >& result)
| Gets the result of a g_socket_connection_connect_async() call. More...
bool | is_connected () const
| Checks if connection is connected. More...
Glib::RefPtr< Socket > | get_socket ()
| Gets the underlying Socket object of the connection. More...
Glib::RefPtr< const Socket > | get_socket () const
| Gets the underlying Socket object of the connection. More...
Glib::RefPtr< SocketAddress > | get_local_address ()
| Try to get the local address of a socket connection. More...
Glib::RefPtr< const SocketAddress > | get_local_address () const
| Try to get the local address of a socket connection. More...
Glib::RefPtr< SocketAddress > | get_remote_address ()
| Try to get the remote address of a socket connection. More...
Glib::RefPtr< const SocketAddress > | get_remote_address () const
| Try to get the remote address of a socket connection. More...
Glib::PropertyProxy_ReadOnly < Glib::RefPtr< Socket > > | property_socket () const
| The underlying GSocket. More...
Public Member Functions inherited from Gio::IOStream
virtual | ~IOStream ()
GIOStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GIOStream* | gobj () const
| Provides access to the underlying C GObject. More...
GIOStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | splice_async (const Glib::RefPtr< IOStream >& stream2, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| Asyncronously splice the output stream to the input stream of stream2, and splice the output stream of stream2 to the input stream of this stream. More...
void | splice_async (const Glib::RefPtr< IOStream >& stream2, const SlotAsyncReady& slot, IOStreamSpliceFlags flags=Gio::IO_STREAM_SPLICE_NONE, int io_priority=Glib::PRIORITY_DEFAULT)
| A non-cancellable version of splice_async(). More...
Glib::RefPtr< InputStream > | get_input_stream ()
| Gets the input stream for this object. More...
Glib::RefPtr< OutputStream > | get_output_stream ()
| Gets the output stream for this object. More...
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it. More...
bool | close ()
| A close() convenience overload. More...
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
bool | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Closes a stream. More...
bool | is_closed () const
| Checks if a stream is closed. More...
bool | has_pending () const
| Checks if a stream has pending actions. More...
bool | set_pending ()
| Sets stream to have actions pending. More...
void | clear_pending ()
| Clears the pending flag on stream. More...
Public Member Functions inherited from Glib::Object
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr < SocketConnection > | create (const Glib::RefPtr< Socket >& socket)
| Creates a SocketConnection subclass of the right type for socket. More...
Static Public Member Functions inherited from Gio::IOStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | splice_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous io stream splice operation. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr < Gio::SocketConnection > | wrap (GSocketConnection* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::IOStream
Glib::RefPtr< Gio::IOStream > | wrap (GIOStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(* | DestroyNotify )(gpointer data)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
virtual | ~Object ()

## Detailed Description

A socket connection.

See Also
  IOStream, SocketClient, SocketListener

SocketConnection is a IOStream for a connected socket. They can be created either by SocketClient when connecting to a host, or by SocketListener when accepting a new client.

The type of the SocketConnection object returned from these calls depends on the type of the underlying socket that is in use. For instance, for a TCP/IP connection it will be a TcpConnection.

Chosing what type of object to construct is done with the socket connection factory, and it is possible for 3rd parties to register custom socket connection types for specific combination of socket family/type/protocol using g_socket_connection_factory_register_type().

Since glibmm 2.24:

## Constructor & Destructor Documentation

virtual Gio::SocketConnection::~SocketConnection | ( |  | ) |
| virtual

## Member Function Documentation

bool Gio::SocketConnection::connect | ( | const Glib::RefPtr< SocketAddress >& | address,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Connect connection to the specified remote address.

Since glibmm 2.32:

Parameters

  address | A SocketAddress specifying the remote address.
  cancellable | A Cancellable or `0`.

Returns
  `true` if the connection succeeded, `false` on error.

bool Gio::SocketConnection::connect | ( | const Glib::RefPtr< SocketAddress >& | address | ) |

A connect() convenience overload.

void Gio::SocketConnection::connect_async | ( | const Glib::RefPtr< SocketAddress >& | address,
|  | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Asynchronously connect this connection to the specified remote address.

This clears the "blocking" flag on this connection's underlying socket if it is currently set.

Use connect_finish() to retrieve the result.

Parameters

  address | A SocketAddress specifying the remote address.
  slot | A SlotAsyncReady slot.
  cancellable | A Cancellable.

Since glibmm 2.36:

void Gio::SocketConnection::connect_async | ( | const Glib::RefPtr< SocketAddress >& | address,
|  | const SlotAsyncReady& | slot
| ) |  |

A non-cancellable version of connect_async().

bool Gio::SocketConnection::connect_finish | ( | const Glib::RefPtr< AsyncResult >& | result | ) |

Gets the result of a g_socket_connection_connect_async() call.

Since glibmm 2.32:

Parameters

  result | The AsyncResult.

Returns
  `true` if the connection succeeded, `false` on error.

static Glib::RefPtr<SocketConnection> Gio::SocketConnection::create | ( | const Glib::RefPtr< Socket >& | socket | ) |
| static

Creates a SocketConnection subclass of the right type for socket.

Since glibmm 2.22:

Returns
  A SocketConnection.

Glib::RefPtr<SocketAddress> Gio::SocketConnection::get_local_address | ( |  | ) |

Try to get the local address of a socket connection.

Since glibmm 2.22:

Returns
  A SocketAddress or `0` on error. Free the returned object with Glib::object_unref().

Glib::RefPtr<const SocketAddress> Gio::SocketConnection::get_local_address | ( |  | ) | const

Try to get the local address of a socket connection.

Since glibmm 2.22:

Returns
  A SocketAddress or `0` on error. Free the returned object with Glib::object_unref().

Glib::RefPtr<SocketAddress> Gio::SocketConnection::get_remote_address | ( |  | ) |

Try to get the remote address of a socket connection.

Since glibmm 2.22:

Returns
  A SocketAddress or `0` on error. Free the returned object with Glib::object_unref().

Glib::RefPtr<const SocketAddress> Gio::SocketConnection::get_remote_address | ( |  | ) | const

Try to get the remote address of a socket connection.

Since glibmm 2.22:

Returns
  A SocketAddress or `0` on error. Free the returned object with Glib::object_unref().

Glib::RefPtr<Socket> Gio::SocketConnection::get_socket | ( |  | ) |

Gets the underlying Socket object of the connection.

This can be useful if you want to do something unusual on it not supported by the SocketConnection APIs.

Since glibmm 2.22:

Returns
  A SocketAddress or `0` on error.

Glib::RefPtr<const Socket> Gio::SocketConnection::get_socket | ( |  | ) | const

Gets the underlying Socket object of the connection.

This can be useful if you want to do something unusual on it not supported by the SocketConnection APIs.

Since glibmm 2.22:

Returns
  A SocketAddress or `0` on error.

static GType Gio::SocketConnection::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GSocketConnection* Gio::SocketConnection::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GSocketConnection* Gio::SocketConnection::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GSocketConnection* Gio::SocketConnection::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gio::SocketConnection::is_connected | ( |  | ) | const

Checks if connection is connected.

This is equivalent to calling g_socket_is_connected() on connection's underlying Socket.

Since glibmm 2.32:

Returns
  Whether connection is connected.

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Socket> > Gio::SocketConnection::property_socket | ( |  | ) | const

The underlying GSocket.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::SocketConnection > wrap | ( | GSocketConnection * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.